#include "punishermodule.h"
#include "message.h"
#include "user.h"
#include <QStringList>

PunisherModule::PunisherModule()
{
    
}

bool PunisherModule::messageHandler(Message msg)
{
    if(msg.args.startsWith("!forbidden remove ") && getUsers()->getFromNick(msg.nick)->isOp())
    {
        QStringList str = msg.args.split(' ');
        int i=2;
        answer = QString("");
        for(; i<str.size(); ++i)
        {
            bool found = false;
            for(auto it = forbidden_words.begin(); it != forbidden_words.end(); it++)
            {
                if(str[i].compare(*it, Qt::CaseInsensitive) == 0)
                {
                    forbidden_words.erase(it);
                    found = true;
                    break;
                }
            }
            if(found)
                answer += say(QString("removed %1 to the list of forbidden words").arg(str[i]));
            else
                answer += say(QString("%1 was not part of the list of forbidden words").arg(str[i]));
            
        }
        if(i==2)
            answer = say(QString("missing argument"));
        return true;
    }
    
    if(msg.args.compare("!forbidden reset") == 0 && getUsers()->getFromNick(msg.nick)->isOp())
    {
        forbidden_words.clear();
        answer = say(QString("removed all forbidden words"));
        return true;
    }
    
    if(msg.args.startsWith("!forbidden add ") && getUsers()->getFromNick(msg.nick)->isOp())
    {
        QStringList str = msg.args.split(' ');
        int i=2;
        answer = QString("");
        for(; i<str.size(); ++i)
        {
            forbidden_words.push_back(str[i]);
            answer += say(QString("added %1 to the list of forbidden words").arg(str[i]));
        }
        if(i==2)
            answer = say(QString("missing argument"));
        return true;
    }
    
    if(msg.args.compare("!forbidden list") == 0)
    {
        QString str = QString("Forbidden words are : ");
        for(const QString &w : forbidden_words)
            str.append(w).append(" ");
        answer = say(str);
        return true;
    }
    
    if(msg.nick.compare("LadySparrow") == 0)
        return false;
    
    for(const QString &w : forbidden_words)
    {
        if(msg.args.contains(w, Qt::CaseInsensitive))
        {
            answer = QString("KICK #%1 %2\r\n").arg(getChan()).arg(msg.nick);
            return true;
        }
    }

    return false;
}

QString PunisherModule::getName()
{
    return QString("punisher");
}
